
<?php
defined('_JEXEC') or die;
$templateName = JFactory::getApplication('site')->getTemplate();
$templateDir = JPATH_THEMES . '/' . $templateName;
require_once $templateDir . '/app/' . 'Editor.php';

if ($way = DesignerEditor::override($templateName, __FILE__)) {
	$editorDir = $templateName . '/editor';
    require($way);
    return;
} else {
?>
<?php
require_once dirname(dirname(dirname(dirname(__FILE__)))) . DIRECTORY_SEPARATOR . 'functions.php';

vmJsApi::js ('facebox');
vmJsApi::css ('facebox');
JHtml::_ ('behavior.formvalidation');
$document = JFactory::getDocument ();
$document->addScriptDeclaration ("

//<![CDATA[
	jQuery(document).ready(function($) {
		$('div#full-tos').hide();
		$('a#terms-of-service').click(function(event) {
			event.preventDefault();
			$.facebox( { div: '#full-tos' }, 'my-groovy-style');
		});
	});

//]]>
");
$document->addScriptDeclaration ("

//<![CDATA[
	jQuery(document).ready(function($) {
	if ( $('#STsameAsBTjs').is(':checked') ) {
				$('#output-shipto-display').hide();
			} else {
				$('#output-shipto-display').show();
			}
		$('#STsameAsBTjs').click(function(event) {
			if($(this).is(':checked')){
				$('#STsameAsBT').val('1') ;
				$('#output-shipto-display').hide();
			} else {
				$('#STsameAsBT').val('0') ;
				$('#output-shipto-display').show();
			}
		});
	});

//]]>

");
$document->addStyleDeclaration ('#facebox .content {display: block !important; height: 480px !important; overflow: auto; width: 560px !important; }');

$this->blockFuncName = 'shoppingcart_block_1';

?>

<div class=" bd-shoppingcart-1">
    <div class=" bd-carttitle-1">
    <h2><?php echo JText::_ ('COM_VIRTUEMART_CART_TITLE'); ?></h2>
</div>
            <?php if (VmConfig::get ('oncheckout_show_steps', 1) && $this->checkout_task === 'confirm') : ?>
                <?php vmdebug ('checkout_task', $this->checkout_task); ?>
                <div class="checkoutStep" id="checkoutStep4">
                    <?php echo JText::_ ('COM_VIRTUEMART_USER_FORM_CART_STEP4'); ?>
                </div>
            <?php endif; ?>
    <div class="row">
        <div class="col-md-8">
            <?php
                echo renderTemplateFromIncludes($this->blockFuncName,
                    array('', shopFunctionsF::getLoginForm ($this->cart, FALSE)));
            ?>
        </div>
        <div class="col-md-8">
            <?php echo $this->loadTemplate('billto'); ?>
        </div>
        <div class="col-md-8">
            <?php echo $this->loadTemplate('shipto'); ?>
        </div>
    </div>
    
    <?php echo $this->loadTemplate ('pricelist'); ?>
    
    <div class="row">
        <div class="col-md-6">
            <?php echo $this->loadTemplate ('info'); ?>
        </div>
        <div class="col-md-18">
    <?php if ($this->checkout_task) : ?>
        <?php $taskRoute = '&task=' . $this->checkout_task; ?>
	<?php else : ?>
        <?php $taskRoute = ''; ?>
	<?php endif; ?>
    
	<div id="checkout-advertise-box">
		<?php
		if (!empty($this->checkoutAdvertise)) {
			foreach ($this->checkoutAdvertise as $checkoutAdvertise) {
				?>
				<div class="checkout-advertise">
					<?php echo $checkoutAdvertise; ?>
				</div>
				<?php
			}
		}
		?>
	</div>

	<form method="post" id="checkoutForm" name="checkoutForm" action="<?php echo JRoute::_ ('index.php?option=com_virtuemart&view=cart' . $taskRoute, $this->useXHTML, $this->useSSL); ?>">

		<?php // Leave A Comment Field ?>
		<div class="customer-comment marginbottom15">
			<span class="comment"><?php echo JText::_ ('COM_VIRTUEMART_COMMENT_CART'); ?></span><br/>
			<textarea class="customer-comment" name="customer_comment" cols="60" rows="1">
			    <?php echo isset($this->cart->customer_comment) ? $this->cart->customer_comment : ''; ?>
			</textarea>
		</div>
		<?php // Leave A Comment Field END ?>
		<?php // Continue and Checkout Button ?>
		<div class="checkout-button-top">
			<?php // Terms Of Service Checkbox
			if (!class_exists ('VirtueMartModelUserfields')) {
				require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'userfields.php');
			}
			$userFieldsModel = VmModel::getModel ('userfields');
            ?>
			<?php if ($userFieldsModel->getIfRequired ('agreed')) : ?>
				<label for="tosAccepted">
					<?php
					if (!class_exists ('VmHtml')) {
						require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'html.php');
					}
					echo VmHtml::checkbox ('tosAccepted', isset($this->cart->tosAccepted) ? $this->cart->tosAccepted : null, 1, 0, 'class="terms-of-service"');
                    ?>
					<?php if (VmConfig::get ('oncheckout_show_legal_info', 1)) : ?>
						<div class="terms-of-service">
							<a href="<?php JRoute::_ ('index.php?option=com_virtuemart&view=vendor&layout=tos&virtuemart_vendor_id=1') ?>" class="terms-of-service" id="terms-of-service" rel="facebox"
							   target="_blank">
								<span class="vmicon vm2-termsofservice-icon"></span>
								<?php echo JText::_ ('COM_VIRTUEMART_CART_TOS_READ_AND_ACCEPTED'); ?>
							</a>
							<div id="full-tos">
								<h2><?php echo JText::_ ('COM_VIRTUEMART_CART_TOS'); ?></h2>
								<?php echo $this->cart->vendor->vendor_terms_of_service; ?>
							</div>

						</div>
                    <?php endif; ?>
				</label>
			<?php endif; ?>
            <?php
    echo str_replace('vm-button-correct', bd-button, $this->checkout_link_html);
?>
		</div>
		<?php // Continue and Checkout Button END ?>
		<input type='hidden' id='STsameAsBT' name='STsameAsBT' value='<?php echo $this->cart->STsameAsBT; ?>'/>
		<input type='hidden' name='task' value='<?php echo $this->checkout_task; ?>'/>
		<input type='hidden' name='option' value='com_virtuemart'/>
		<input type='hidden' name='view' value='cart'/>
	</form>
</div>
    </div>

</div>
<?php } ?>
